/*
 * $RCSfile: blast_debug.c,v $
 *
 * x-kernel v3.3
 *
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 *
 * $Log: blast_debug.c,v $
 * Revision 1.3  1996/01/29 22:08:39  slm
 * Updated copyright and version.
 *
 * Revision 1.2  1995/08/03  19:14:41  davidm
 * 64-bit cleanup and x3.2->x3.3 conversion.
 *
 * Revision 1.1  1995/07/28  22:08:26  slm
 * Initial revision
 *
 * Revision 1.13.1.1  1994/11/23  17:28:49  hkaram
 * New branch
 *
 * Revision 1.13  1993/12/15  23:37:31  menze
 * Fixed blastShowMask() to compile with strict ANSI restrictions
 */

#include "blast_internal.h"


void
blast_phdr(hdr)
    BLAST_HDR *hdr;
{
    xTrace1(blastp, TR_ALWAYS, "BLAST header: %s", blastOpStr(hdr->op));
    xTrace5(blastp, TR_ALWAYS,
	    " p: %d  sq: %d  f: %d  m: %s  l: %d",
	    hdr->prot_id, hdr->seq, hdr->num_frag,
	    blastShowMask(hdr->mask), hdr->len);
}


char *
blastOpStr(op)
    int op;
{  
    switch (op) {
      case BLAST_SEND: 		return "SEND";
      case BLAST_RETRANSMIT:	return "REXMIT";
      case BLAST_NACK:		return "NACK";
      default:			return "INVALID";
    }
}	


void
blastShowActiveKey(k, message)
    ActiveID *k;
    char *message;
{
    xTrace3(blastp, TR_ALWAYS, "%s active key:  lls = %x  prot = %d",
	   message, k->lls, k->prot);
}    
  

void
blastShowMstate(m, message)
    MSG_STATE *m;
    char *message;
{
    xTrace1(blastp, TR_ALWAYS, "%s mstate:", message);
    xTrace1(blastp, TR_ALWAYS, "   mask = %s", blastShowMask(m->mask));
    xTrace1(blastp, TR_ALWAYS, "oldMask = %s", blastShowMask(m->old_mask));
    blast_phdr(&m->hdr);
}


char *
blastShowMask( m )
    BLAST_MASK_PROTOTYPE m;
{
    static char buf[2 * BLAST_MAX_FRAGS];
    char 	*b;
    int 	i;

    for ( b=buf, i = BLAST_MAX_FRAGS; i > 0; i--) {
	if (i && ! (i % 4)) {
	    *b++ = ' ';
	}
	*b++ = (BLAST_MASK_IS_BIT_SET(&m, i)) ? '1' : '0';
    }
    *b = 0;
    return buf;
}


